#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <map>
#include <cstdio>

using namespace std;

inline int abs(int x) { return x > 0 ? x : -x; }

int n, m;

map<int, pair<int,int>> wh;

int ri, rj;

short v3[210][105][105];

bool checkNewInt(int dist, int n,  int m, int &pi, int &pj) {
    for (int i = 0; i < n; ++i) {
        int s = 0;
        for (int j = 0; j < m; ++j) {
           s += v3[dist][i][j];
           if (s == 0) {
                pi = i;
                pj = j;
                return true;
           }
        }
    }
    return false;
}

pair<int,int> v[10010];

int main() {
        int k;
        cin >> n >> m >> k;

        std::vector<std::pair<int, int>> v;

        for (int i = 1; i <= k; ++i) {
             int s, f;
             cin >> s >> f;
             v[2*i-2] = std::make_pair(s, -i);
             v[2*i-1] = std::make_pair(f, i);
        }

        std::sort(v.begin(), v.end());

        int maxd = n + m + 3;

        for (int kk = 0; kk < 2*k; ++kk) {
                if (v[kk].second < 0) { // enter
                        int down = 0, up = maxd;
                        int pi;
                        int pj;
                        while (up - down > 1) {
                                int t = (up + down) / 2;
                                if (!checkNewInt(t, n, m, pi, pj))
                                        up = t;
                                else
                                        down = t;
                        }
                        ri = 100500, rj = 100500;
                        // ищем самую левую верхнюю точку

                        if (!checkNewInt(down, n, m, ri, rj)) {
                            printf("-1 -1\n");
                        } else {
                printf("%d %d\n",ri+1, rj+1);
                            for (int dd = 0; dd < maxd; ++dd) {
                                for (int i=0; i < n; ++i) {
                                     int l = abs(i - ri);
                                     int ddd = dd - l;
                     if (ddd<0) continue;
                                     int lrj = rj - ddd;
                                     int rrj = rj + ddd + 1;
                                     if (lrj < 0) {
                                          lrj = 0;
                                     }
                                     if (rrj > m) {
                                         rrj = m;
                                     }

                                     v3[dd][i][lrj]++;
                                     v3[dd][i][rrj]--;
                                }
                            }
                        }
                        wh[-v[kk].second] = make_pair(ri, rj);
                } else {
                        // удаляем
                        auto [ri, rj] = wh[v[kk].second];
                        wh.erase(v[kk].second);
                            for (int dd = 0; dd < maxd; ++dd) {
                                for (int i=0; i < n; ++i) {
                                     int l = abs(i - ri);
                                     int ddd = dd - l;
                                     if (ddd < 0) continue;
                                     int lrj = rj - ddd;
                                     int rrj = rj + ddd + 1;
                                     if (lrj < 0) {
                                          lrj = 0;
                                     }
                                     if (rrj > m) {
                                         rrj = m;
                                     }

                                     v3[dd][i][lrj]--;
                                     v3[dd][i][rrj]++;
                                }
                            }
                }
        }
        return 0;
}
