#include "testlib.h"
#include <iostream>
#include <set>
#include <algorithm>
#include <map>
using namespace std;

void writeTest(int test, int n, int m, int q, double _pRemove)
{
	int pRemove = (int)(_pRemove * 1000.0);
    startTest(test);
    cout << n << " " << m << " " << q << "\n";
    set<int> active;
    map<int, pair<int, int>> tt;
    int empty = n * m;
    int t = 5;
    for (int i = 0; i < q; ++i) {
    	if (active.size() > 0 && (rnd.next(1000) < pRemove || empty <= 1)) {
    		int cnt = rnd.next((long long)active.size());
    		set<int>::iterator it = active.begin();
    		while (cnt) ++it, --cnt;
		tt[*it].second = i + 1;
		++t;
    		active.erase(*it);
    		++empty;
    	} else {
    	    active.insert(i + 1);
	    tt[i+1].first = i + 1;
	     tt[i+1].second = 0;
	     ++t;
    	    --empty;
    	}
    }
    for (auto &[_, p] : tt) {
       if (p.second ==0) {
	     ++t;
             p.second = t;
	        }
       cout << p.first << " " << p.second << endl;
    }
}

int main(int argc, char* argv[])
{
    registerGen(argc, argv);

    int test = 2;
  	writeTest(++test, 4, 4, 8, 0.2);
  	writeTest(++test, 5, 10, 20, 0.2);
   	writeTest(++test, 30, 20, 50, 0.0);
  	writeTest(++test, 30, 20, 100, 0.3);
  	writeTest(++test, 100, 100, 100, 0.3);
  	writeTest(++test, 100, 100, 1000, 0.0);
  	writeTest(++test, 100, 100, 5000, 0.2);
  	writeTest(++test, 100, 100, 1400, 0.1);
  	writeTest(++test, 100, 100, 5000, 0.0);
  	writeTest(++test, 100, 100, 100, 0.3);
  	writeTest(++test, 100, 100, 5000, 0.3);

	for (int i = 0; i < 20; ++i) {
  		int n = rnd.next(1, 100);
  		int m = rnd.next(1, 100);
  		int q = 5000;
		double pRemove = rnd.next(500) * 0.001;
		writeTest(++test, n, m, q, pRemove);
  	}
    
    return 0;
}
