import java.io.FileInputStream;
import java.util.Arrays;
import java.util.Scanner;

public class update_sol {
	static int n, k;
	static int time_max; // final moment
    static int last_batch; // number of peers that come online at the final moment
	static int solution;
	
	private void read() {
		Scanner s = new Scanner(System.in);
		n = s.nextInt() - 1; // number of peers
		k = s.nextInt(); // number of pieces
		time_max = -1; 
	        int tmp = s.nextInt();
		for (int i=0; i<n; i++) {
		    int time = s.nextInt();
		    if (time > time_max) {
		        time_max = time;
		        last_batch = 1;
		    } else if (time == time_max) {
		        last_batch++;
		    }
		}
	}
	
	private void solve() {
	    int prev_swarm = n-last_batch;
	    int first_step = prev_swarm+1;
	    int next_steps = n;
        solution = time_max + 1;
	    if (first_step < k) {
	        int remainder = (k-first_step);
	        solution += remainder / next_steps;
	        if (remainder % next_steps > 0) {
	            solution++;
	        }
	    }
	}
	
	private void write() {
	    System.out.println("" + solution);
	}
	
	private void run() {
          read();
          solve();
          write();
	}
	                             
	public static void main(String[] args) {
	    (new update_sol()).run();
	}
}
